<template>
  <CModal
    :show.sync="isOpen"
    :close-on-backdrop="false"
    addContentClasses="modal-window"
  >
    <template #header>
      <h5>Удаление пользователя</h5>
      <CButton
        variant="ghost"
        @click="closeModal(false)"
      >
        <CIcon
          name="cilX"
        />
      </CButton>
    </template>
    <template #footer>
      <CButton
        color="secondary"
        @click="closeModal(false)"
      >
        Нет, не удалять
      </CButton>
      <CButton
        color="primary"
        @click="closeModal(true)"
      >
        Да, удалить
      </CButton>
    </template>
    <div>
      <p>Вы уверены что хотите удалить пользователя {{userName}} ?</p>
      <p>Это действие невозможно отменить.</p>
    </div>
  </CModal>
</template>

<script>
  import modalClosingDuration from "../../../../constants/modalClosingDuration";

  export default {
    name: "DeletionUser",
    props: {
      isOpen: {
        // Состояние модального окна
        type: Boolean,
        default: false,
      },
      userInfo: {
        // Информация об удаляемом пользователе
        type: Object,
        default() {
          return {};
        },
      },
    },
    data() {
      return {
        user: {},
      };
    },
    computed: {
      userName() {
        return this.user.name;
      },
    },
    watch: {
      isOpen(value) {
        if (value) {
          this.user = {...this.userInfo};
        } else {
          setTimeout(() => this.clearData(), modalClosingDuration);
        }
      },
    },
    methods: {
      closeModal(closeType) {
        this.$emit('onClose', {closeType, data: this.user, modalType: 'deleteUser'});
      },
      clearData() {
        this.user = {};
      },
    },
  }
</script>
